import 'dart:convert';

import '../../src/db.dart';
import '../../src/utils.dart';

class Tap {
  DB _db;

  Tap(DB db) {
    _db = db;
  }

  /// 点击
  void onTap(
      {String pageId, String clickId, Map<String, dynamic> extras}) async {
    int clickTime = Utils.getDateNow();
    String extrasStr = json.encode(extras);
    String id = Utils.md5("${pageId}_${clickId}_${extrasStr}_$clickTime");
    Map<String, dynamic> map = {
      "id": id,
      "page_id": pageId,
      "click_id": clickId,
      "click_time": clickTime,
      "extras": extrasStr,
    };
    Map<String, dynamic> common = await Utils.getCommonParams();
    map.addAll(common);

    await _db.ready;
    Utils.log("tap", map);
    await _db.db.insert("tap_tj", map);
  }

  // 上传数据至接口
  void upload() async {
    await _db.ready;
    List<Map> list = await _db.db.query("tap_tj", limit: 100, offset: 0);
    if (list.length == 0) {
      return;
    }
    String deviceId = await Utils.getDeviceId();
    bool result = await Utils.uploadData({
      "device_id": deviceId,
      "projects": [
        {"event_name": "elem_click", "event_data": list}
      ]
    });
    if (result) {
      List<String> ids = List<String>.from(list.map((e) => e['id']).toList());
      await _db.db
          .rawDelete("delete from tap_tj where id in('${ids.join("','")}')");
    }
    if (Utils.isDebug) {
      Utils.log("tap_tj upload_result", {"ok": result, "length": list.length});
    }
    if (list.length == 100) {
      upload();
    }
  }
}
